#ifndef EXPLOSION_H_INCLUDED
#define EXPLOSION_H_INCLUDED

#include "common.h"
#include "time.h"
#include "graphics.h"

struct Explosion {
	Pipeline* 			pipeline 		= 0;
	ho::vector2f 		position;
	ho::vector2f 		dimensions;
	float 				damage 			= 0;
	Animation			animation;

	Explosion(Pipeline* PIPELINE) {
		pipeline 				= PIPELINE;
		dimensions 				= ho::vector2f(100, 100);
		damage 					= 4;
		animation.frame_delay 	= 25;
		animation.frame_size 	= dimensions;
		animation.max_frames 	= 10;
		animation.sprite.set_texture(PIPELINE->graphics->get_texture("explosion"));
		animation.sprite.set_dimensions(dimensions);
		animation.timer.set_duration(animation.frame_delay * animation.max_frames);
	}

	std::pair<ho::vector2f, ho::vector2f> get_collision() {
		return std::pair<ho::vector2f, ho::vector2f>(position, dimensions / ho::vector2f(2, 2));
	}
};

#endif // EXPLOSION_H_INCLUDED
