#ifndef TEXTURES_H_INCLUDED
#define TEXTURES_H_INCLUDED

#include <vector>
#include <map>
#include "common.h"
#include "external/lodepng/lodepng.h"
#include "time.h"

struct Animation {
	ho::opengl::Sprite 		sprite;
	ho::Timer 				timer;
	float 					frame_delay		= 0;
	int 					max_frames 		= 0;
	ho::vector2f 			frame_size;

	void update() {
		int current_frame = std::min((int)(timer.milliseconds() / frame_delay), max_frames);
		sprite.set_window(ho::vector2f(current_frame * frame_size[0], 0), frame_size);
	}
};

class Graphics {
public:
							~Graphics();
	bool 					load(ho::Config &FACTORY);
	ho::opengl::Texture* 	get_texture(ho::String NAME);
	ho::opengl::TrueType* 	get_font(ho::String NAME);

private:
	bool import_png(ho::String FILENAME, ho::String NAME);
	bool import_truetype(ho::String FILENAME, ho::String NAME, int SIZE);

	std::map<ho::String, ho::opengl::Texture*> 	textures;
	std::map<ho::String, ho::opengl::TrueType*> 	fonts;
};

#endif // TEXTURES_H_INCLUDED
