#ifndef PIPELINE_H_INCLUDED
#define PIPELINE_H_INCLUDED

#include "../HyperOpticLibrary/ho.h"

class Graphics;
class Sound;
class Time;
class Input;

struct KeyBindings {
	unsigned ESC 		= 27;
	unsigned UP 		= 83;
	unsigned LEFT 		= 68;
	unsigned DOWN 		= 87;
	unsigned RIGHT 	= 65;
	unsigned SHOOT 	= 32;
};

struct Pipeline {
	// Objects
	ho::Config 			config;
	ho::Config 			factory;
	Graphics* 			graphics;
	Sound* 				sound;
	Input* 				input;
	ho::opengl::Canvas 	world_canvas;
	ho::opengl::Canvas 	overlay_canvas;
	ho::opengl::Canvas 	hud_canvas;

	// Shared members
	ho::vector2 		resolution 				= ho::vector2(1280 / 2, 720 / 2);
	ho::vector2 		window_dimensions;
	ho::vector4f		screen_bounds;
	KeyBindings 		keys;
	bool 				focused 				= true;
	bool 				closing 				= false;
	bool 				stretch 				= true;
	int 				vsync 					= 0;
	bool 				swap_buffers 			= true;
	bool 				clip_cursor 			= false;

};

#endif // PIPELINE_H_INCLUDED
