#ifndef PLAYER_H_INCLUDED
#define PLAYER_H_INCLUDED

#include "common.h"
#include "graphics.h"
#include "sound.h"
#include "input.h"
#include "enemy.h"
#include "bullet.h"

class Match;

class Player {
public:
												Player(Pipeline* PIPELINE, Match* MATCH);
												~Player();
	void 										update();
	void 										render();
	void 										set_level(int LEVEL);
	void 										damage(float AMOUNT);
	bool 										dead();
	std::pair<ho::vector2f, ho::vector2f> 	get_collision();

private:
	enum Weapon {GUN, DOUBLE_GUN, LASER};

	void handle_input();
	void update_position();
	void update_shooting();

	Pipeline* 					pipeline;
	Match*						match;
	ho::opengl::Sprite 			sprite;
	ho::vector2f 				position;
	ho::vector2f 				dimensions;
	ho::vector2f 				sprite_offset;
	float						move_speed;
	float 						shoot_offset;
	ho::Timer 					life_timer;
	ho::Timer 					shoot_timer;
	ho::Timer 					damaged_timer;
	float 						damaged_offset;
	bool 						fire;
	int 						level;
	Weapon 						weapon;
	float 						full_health;
	float						health;
	bool						killed;
	ho::opengl::Primitive2d 	health_bar_green;
	ho::opengl::Primitive2d 	health_bar_red;
	ho::opengl::Primitive2d 	health_bar_border;
};

#endif // PLAYER_H_INCLUDED
